Bug 226987 - lang/rexx-imc: fails to link wtih lld as the system linker
Summary: lang/rexx-imc: fails to link wtih lld as the system linker
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: freebsd-ports-bugs mailing list
URL:
Keywords:
Depends on:
Blocks: 214864
  Show dependency treegraph
 
Reported: 2018-03-27 15:52 UTC by Ed Maste
Modified: 2018-03-29 10:40 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ed Maste freebsd_committer 2018-03-27 15:52:01 UTC
I'm working on switching to LLVM's lld linker as the FreeBSD system linker (/usr/bin/ld)[1], and the port in this PR is reported as a new failure in the exp-run, PR 214864.

An excerpt from the build log[2]:
---
ld -shared --export-dynamic -o rxmathfn.rxfn rxmathfn.o -lm
ld: error: unable to find library -lm
---
Known issues in this port or in lld that affect this port:

(2) lld has no built-in search paths (/lib, /usr/lib). Normally the linker is invoked from the compiler driver, and the search paths are added by the compiler. If lld is invoked directly library search paths must be specified explicitly, with -L/lib -L/usr/lib.

FreeBSD 11 and later have lld available as /usr/bin/ld.lld, so one simple option for testing is to just symlink /usr/bin/ld to ld.lld (and restore it to ld.bfd).

A port Makefile knob, LLD_UNSAFE=yes, exists to indicate that a port does not work with lld, and requires either /usr/bin/ld.bfd or binutils from ports. This should work for the common case of ports written in C using GNU autoconf; it may have no effect on other ports.

[1] https://lists.freebsd.org/pipermail/freebsd-current/2018-March/068985.html
[2] http://package18.nyi.freebsd.org/data/headamd64PR214864-default/2018-03-21_17h43m11s/logs/errors/rexx-imc-1.76_3.log
Comment 1 Ed Maste freebsd_committer 2018-03-27 20:55:50 UTC
Via tobik@ in ports r465725, BINARY_ALIAS=ld=ld.bfd may be an effective workaround if LLD_UNSAFE does not work.
Comment 2 Ed Maste freebsd_committer 2018-03-28 01:06:47 UTC
Followup, if BINARY_ALIAS is used it should be in addition to LLD_UNSAFE, so that architectures without a /usr/bin/ld.bfd (arm64) work. If possible LLD_UNSAFE=yes should imply BINARY_ALIAS=ld=ld.bfd, under discussion on the ports mailing list.
Comment 3 commit-hook freebsd_committer 2018-03-29 10:40:42 UTC
A commit references this bug:

Author: krion
Date: Thu Mar 29 10:40:29 UTC 2018
New revision: 465881
URL: https://svnweb.freebsd.org/changeset/ports/465881

Log:
  Switch to ld.bfd by default as ld.ldd doesn't have built-in default
  output target.

  PR:		226987
  Submitted by:	emaste
  Approved by:	portmgr (LLD_UNSAFE blanket)

Changes:
  head/lang/rexx-imc/Makefile